#!/bin/bash

# shell script to ease the use of Puppet from the command line
# Antonino Sabetta - antonino.sabetta@isti.cnr.it

# 
PUPPET_DIR=PuppetD4.4

# relative to PUPPET_DIR
PUPPET_LIBS=puppetLibs
PUPPET_EXT_LIBS=externalLibs

PUPPET_LIB_LIST="MappedQC.jar MappedSLO.jar puppetQC.jar puppetScope.jar puppetSLO.jar puppetTerm.jar trueGTList.jar wsagreement.jar mobilityPatterns.jar"

PUPPET_EXT_LIB_LIST="activation.jar antlr-2.7.7.jar axis-ant.jar axis.jar commons-discovery.jar commons-logging.jar ini4j-compat.jar ini4j.jar java-getopt-1.0.13.jar jaxrpc.jar jdom.jar jsr173_1.0_api.jar log4j-1.2.8.jar mail.jar minerva2.jar retroweaver-rt-1.2.1.jar saaj.jar SSMSimulator3.jar stringtemplate.jar uk.ac.ucl.cs.slangta_0.0.1.jar wsdl4j.jar xbean.jar xercesImpl.jar xmlsec.jar"

CLASSPATH=""

for LIB in `echo ${PUPPET_LIB_LIST}`;
do
  if [ ! -e "${PUPPET_LIBS}/${LIB}" ]
  then
      echo "PUPPET Lib \"${LIB}\" not found in \"${PUPPET_LIBS}\""
      exit
  fi
  CLASSPATH="${CLASSPATH}:${PUPPET_LIBS}/${LIB}"
done

for LIB in `echo ${PUPPET_EXT_LIB_LIST}`;
do
  if [ ! -e "${PUPPET_EXT_LIBS}/${LIB}" ]
  then
      echo "External Lib \"${LIB}\" not found in \"${PUPPET_EXT_LIBS}\""
      exit
  fi
  CLASSPATH="${CLASSPATH}:${PUPPET_EXT_LIBS}/${LIB}"
done

CLASSPATH=`echo ${CLASSPATH} | sed 's/^://'`

# echo $CLASSPATH
# exit

# CLASSPATH=${PUPPET_LIBS}/MappedQC.jar:\
# ${PUPPET_LIBS}/MappedSLO.jar:\
# ${PUPPET_LIBS}/puppetQC.jar:\
# ${PUPPET_LIBS}/puppetScope.jar:\
# ${PUPPET_LIBS}/puppetSLO.jar:\
# ${PUPPET_LIBS}/puppetTerm.jar:\
# ${PUPPET_LIBS}/trueGTList.jar:\
# ${PUPPET_LIBS}/wsagreement.jar:\
# ${PUPPET_LIBS}/mobilityPatterns.jar:\
# ${PUPPET_EXT_LIBS}/activation.jar:\
# ${PUPPET_EXT_LIBS}/antlr-2.7.7.jar:\
# ${PUPPET_EXT_LIBS}/axis-ant.jar:\
# ${PUPPET_EXT_LIBS}/axis.jar:\
# ${PUPPET_EXT_LIBS}/commons-discovery.jar:\
# ${PUPPET_EXT_LIBS}/commons-logging.jar:\
# ${PUPPET_EXT_LIBS}/ini4j-compat.jar:\
# ${PUPPET_EXT_LIBS}/ini4j.jar:\
# ${PUPPET_EXT_LIBS}/java-getopt-1.0.13.jar:\
# ${PUPPET_EXT_LIBS}/jaxrpc.jar:\
# ${PUPPET_EXT_LIBS}/jdom.jar:\
# ${PUPPET_EXT_LIBS}/jsr173_1.0_api.jar:\
# ${PUPPET_EXT_LIBS}/log4j-1.2.8.jar:\
# ${PUPPET_EXT_LIBS}/mail.jar:\
# ${PUPPET_EXT_LIBS}/minerva2.jar:\
# ${PUPPET_EXT_LIBS}/retroweaver-rt-1.2.1.jar:\
# ${PUPPET_EXT_LIBS}/saaj.jar:\
# ${PUPPET_EXT_LIBS}/SSMSimulator3.jar:\
# ${PUPPET_EXT_LIBS}/stringtemplate.jar:\
# ${PUPPET_EXT_LIBS}/uk.ac.ucl.cs.slangta_0.0.1.jar:\
# ${PUPPET_EXT_LIBS}/wsdl4j.jar:\
# ${PUPPET_EXT_LIBS}/xbean.jar:\
# ${PUPPET_EXT_LIBS}/xercesImpl.jar:\
# ${PUPPET_EXT_LIBS}/xmlsec.jar

if [ -z $1 ];
then
    echo "No argument supplied."
    echo "Please specify a valid puppet initialization file."
    echo "  example:"
    echo "    puppet.sh example/eHealthScenario3/configuration.ini "
    echo "Exiting."
    exit
fi

java -cp $CLASSPATH:puppet.jar puppet.Puppet $1















