package puppet;


import it.cnr.isti.setest0.mappedSLO.MappedSLODocument;
import it.cnr.isti.setest0.puppetSLO.PuppetSLODocument.PuppetSLO;

import org.antlr.stringtemplate.StringTemplate;

import constant.Constant;

public class Reliability 
{
    private String ambitionMode;
    
    public Reliability( String ambitionMode ){
        this.ambitionMode = ambitionMode;
    }

    public Reliability(){
        this.ambitionMode = Constant.AMBITION_MODE_OFF;
    }
	
	public String prepareReliability(PuppetSLO puppet,String TipoObligated,MappedSLODocument puppet_slomapped)
	{
		String StringReady ="";
		if(TipoObligated.equals("ServiceProvider"))
		{
			if(puppet.getReliability()!=null)
			{
				System.out.println("------------------------------------------------");
				System.out.println("Reliability");
				String PercentualRelia=puppet.getReliability().getReliabilityPerc().toString();
				//Verifico che tipo di Distribuzione
				String window = puppet.getReliability().getReliabilitywindow().toString();
				//Tipo poisson
				try
				{
					if(puppet.getReliability().getDistribution().getPoisson()!=null)
					{
						
						String intensity = puppet.getReliability().getDistribution().getPoisson().getIntensity().toString();
						//System.out.println(puppet.getReliability().getDistribution().getPoisson().getIntensity());
						
						String Reliability_string = puppet_slomapped.getMappedSLO().getReliability().getDistribution().getPoisson();
						StringTemplate Reliability_string_templ = new StringTemplate(Reliability_string);
						Reliability_string_templ.setAttribute("perc",PercentualRelia);
						Reliability_string_templ.setAttribute("intens",intensity);
						System.out.println(intensity);
						Reliability_string_templ.setAttribute("windows", window);
						StringReady = StringReady + Reliability_string_templ.toString();
						//System.out.println(StringReady);
					}
					else
					{
						if(puppet.getReliability().getDistribution().getGaussian()!=null)
						{
							String Relia_string = puppet_slomapped.getMappedSLO().getReliability().getDistribution().getGaussian();					
							StringTemplate Reliability_string_templ = new StringTemplate(Relia_string);
							Reliability_string_templ.setAttribute("perc",PercentualRelia);
							Reliability_string_templ.setAttribute("windows", window);
							StringReady = StringReady + Reliability_string_templ.toString();
						}
					}
				}	
				catch(Exception e){}

			}	
		}
        
      if (ambitionMode.equals(Constant.AMBITION_MODE_OFF)){
          // Comment useless ambition statements
            StringReady = StringReady.replaceAll(Constant.AMBITION_SIMULATOR_UNDO_REG_EXPR, "/* "+ Constant.AMBITION_SIMULATOR_UNDO_STATEMENT +" */");
        }
      
		//System.out.println("Reliability.....");
		return StringReady;
	}
}
