package puppet;


import it.cnr.isti.setest0.mappedSLO.MappedSLODocument;
import it.cnr.isti.setest0.puppetSLO.PuppetSLODocument;
import it.cnr.isti.setest0.puppetSLO.PuppetSLODocument.PuppetSLO;
import it.cnr.isti.setest0.puppetScope.PuppetScopeDocument.PuppetScope;

import java.io.File;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.GuaranteeTermType;

import constant.Constant;

public class ServiceLevelObjectiveManipulator 
{
	private String mapSLOFile = "";
    private String ambitionMode;
    
	public ServiceLevelObjectiveManipulator(String SLOFile, String ambitionMode)
	{
		mapSLOFile = SLOFile;
        this.ambitionMode = ambitionMode;
	}
	
    public ServiceLevelObjectiveManipulator(String SLOFile)
    {
        mapSLOFile = SLOFile;
        this.ambitionMode = Constant.AMBITION_MODE_OFF;
    }

    public MappedSLODocument getSloMapped()
	{
		MappedSLODocument puppet_slomapped = null;
		//carico il file xml in cui ho mappato il codice
		File mappedFile = null;
		try
		{
			mappedFile=new File(mapSLOFile);
			//Puppet_mapped = PuppetMappedDocument.Factory.parse(mappedFile);
			puppet_slomapped = MappedSLODocument.Factory.parse(mappedFile);
		}
		catch(Exception e)
		{
			System.out.println(e);
		}
		return puppet_slomapped;
	}
//-***************************************************************************************
	public PuppetSLODocument getServiceLevelObjective(GuaranteeTermType GTT)
	{
		System.out.println("getServiceLevelObjective....");
		Object obj = null;
		PuppetSLODocument SLODoc = null;
		try
		{	
			obj=GTT.getServiceLevelObjective();			
			SLODoc=PuppetSLODocument.Factory.parse(obj.toString());
		}	
		catch(Exception e)
		{System.out.println("Parse_WSA2: "+e);}
		
		return SLODoc;
	}
	
//	-***************************************************************************************
	//public  String MapServiceLevelObjective(PuppetSLO puppet,String source, String dest, String service)
	public  String MapServiceLevelObjective(PuppetSLO puppet,String TipoObligated,PuppetScope puppetScope)
	{
		System.out.println("MapServiceLevelObjective....");
		Reliability reliability = new Reliability(ambitionMode);
		Latency latenza = new Latency();
		String StringReady="";
		MappedSLODocument puppet_slomapped = this.getSloMapped();
		//carico il file xml in cui ho mappato il codice
		StringReady = StringReady + latenza.prepareLatency(puppet, TipoObligated, puppet_slomapped);
		StringReady = StringReady + reliability.prepareReliability(puppet, TipoObligated, puppet_slomapped);
		return StringReady;
		
	}

//	-***************************************************************************************	
	public String getSLOImport(String TipoQoS)
	{
		System.out.println("getSLOImport....");
		String ritorno="";
		//String source="/Users/Aran/Documents/Tirocinio/Documentazione/Aran/PuppetMapped.xml";
		File mappedFileSLO = null;
		//PuppetMappedDocument Puppet_mapped = null;
		MappedSLODocument puppet_slomapped = null;
		//carico il file xml in cui ho mappato il codice
		try
		{
			mappedFileSLO=new File(mapSLOFile);
			puppet_slomapped = MappedSLODocument.Factory.parse(mappedFileSLO);	
			//Puppet_mapped = PuppetMappedDocument.Factory.parse(mappedFile);
			if(TipoQoS.endsWith("Latency"))
			{
				ritorno = puppet_slomapped.getMappedSLO().getLatency().getImport();
				
			}
			if(TipoQoS.equals("Reliability"))
			{
				ritorno = puppet_slomapped.getMappedSLO().getReliability().getImport();
				
			}
			if(TipoQoS.equals("WorkLoad"))
			{
				ritorno = puppet_slomapped.getMappedSLO().getWorkLoad().getImport();	
				
			}
		}
		catch(Exception e)
		{
			System.out.println(e);
		}
		
		return ritorno;
	}
	public String getSLOStatic(String TypeOfQOS)
	{
		String ritorno="";
		System.out.println("getSLOStatic");
		File mappedFileSLO = null;
		//PuppetMappedDocument Puppet_mapped = null;
		MappedSLODocument puppet_slomapped = null;
		//carico il file xml in cui ho mappato il codice
		try
		{
			mappedFileSLO=new File(mapSLOFile);
			//Puppet_mapped = PuppetMappedDocument.Factory.parse(mappedFile);
			puppet_slomapped = MappedSLODocument.Factory.parse(mappedFileSLO);
			if(TypeOfQOS.equals("Reliability"))
			{
				ritorno = puppet_slomapped.getMappedSLO().getReliability().getStatic();
			}
			if(TypeOfQOS.equals("WorkLoad"))
			{
				ritorno = puppet_slomapped.getMappedSLO().getWorkLoad().getStatic();
			}
		}
		catch(Exception e)
		{
			return ritorno;
		}
		return ritorno;
	}
//---********************************************************************
	public String getWorkLoad_Function(PuppetSLO puppet,String TipoObligated,PuppetScope puppetScope )
	{
		System.out.println("ServiceLevelObj : GetWorkLoadFunction");
		String ritorno="";
		WorkLoad work_load = null;
		MappedSLODocument puppet_slomapped = null;
		try
		{
			work_load = new WorkLoad();
			puppet_slomapped = this.getSloMapped();
			ritorno = puppet_slomapped.getMappedSLO().getWorkLoad().getFunctions();
			String rit_WL = work_load.prepareWorkLoad(puppet, TipoObligated, puppetScope, puppet_slomapped);
			ritorno = ritorno+rit_WL;
		}
		catch(Exception e)
		{
			System.out.println("ServiceLevelObjective getWorkLoad_functions "+e);
		}

		return ritorno;
	}
}
