package puppet;


//import it.cnr.isti.setest0.puppet.ConditionDocument;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.regex.Pattern;
import java.util.regex.Matcher;


import org.ggf.schemas.graap.x2005.x09.wsAgreement.AgreementOfferDocument;


public class Support 
{
	private String Destination;
	private String Source;
	
	public Support(){}
    
//	Check OK
	public AgreementOfferDocument getAgreementOffer(String filename)
	{
		AgreementOfferDocument puppetDoc = null;
		File ws_file=null;
		try
		{
			ws_file=new File(filename);
		}
		catch(Exception e)
		{System.out.println("Support:AgreementOfferDocument "+e);}
		try
		{	
			puppetDoc = AgreementOfferDocument.Factory.parse(ws_file);	
		}
		catch(Exception e)
		{System.out.println("Support:AgreementOfferDocument "+e);}
		return puppetDoc;
	}
//	-***************************************************************************************	
	/*Prende in input il codice java generato da WSDL2Java e ci inserisce i tag per l'utilizzo 
	 * successivo di StirngTemplate:
	 * code per l'inserimento del codice mappato
	 * import per l'inserimento degli import necessari
	 * WL_function per l'inserimento delle funzioni di supporto come generateTraffic() etc..
	 */
	public String PrepareWorkLoadJavaSource(String Java)
	{
		System.out.println("Support:PrepareWorkLoadJavaSource");
		String JavaString =Java;
		StringBuffer buffer=null;
		StringBuffer javabuffer = new StringBuffer(Java);
		buffer = new StringBuffer("%code%");
		//System.out.println(NomeMetodo);
		try
		{
			//JavaString = JavaString.replaceAll("public class", "%import% public class ");
			String stringa_implement = "\\s+implements\\s+[a-zA-Z\\p{Punct}\\p{Alnum}]+\\s+";
			Pattern pattern_implement = Pattern.compile(stringa_implement,Pattern.MULTILINE);
			Matcher m_implement = pattern_implement.matcher(JavaString);
			while(m_implement.find())
			{
				//System.out.println("++++++++++++++++++++++++++++++Trovato un match!"+ m_implement.group());
				JavaString=m_implement.replaceFirst(" {");
				
			}
			
			String stringa_class = "public\\s+class\\s+\\p{Alpha}[\\p{Punct}*\\p{Alnum}*]+\\s+[{]*";
			Pattern pattern_class = Pattern.compile(stringa_class,Pattern.MULTILINE);
			Matcher m_class = pattern_class.matcher(JavaString);
			while(m_class.find())
			{
				//System.out.println("Trovato un match!"+ m_class.group());
				JavaString=m_class.replaceAll("%import%"+m_class.group()+"%static% %WL_Function% ");
				
			}
			JavaString=JavaString.replace("%", "$");
			
			//System.out.println(JavaString);
			
		}
		catch(Exception e){System.out.println("Support:PrepareWorkLoadJavaSource"+e);}
		return JavaString;
	}
	//---*******************************************************************************
	public String PrepareReliabilityJavaSource(String source,String NomeMetodo)
	{
		String NewString = "";
		String stringa_implement = NomeMetodo.substring(0, NomeMetodo.length()-3);
		try
		{
			//JavaString = JavaString.replaceAll("public class", "%import% public class ");
			Pattern pattern_implement = Pattern.compile(stringa_implement,Pattern.MULTILINE);
			Matcher m_implement = pattern_implement.matcher(source);
			while(m_implement.find())
			{
				NewString = m_implement.group().substring(0,m_implement.group().length()-34)+",String ID) throws java.rmi.RemoteException ";
				source=m_implement.replaceFirst(NewString);	
			}
		}
		catch(Exception e){System.out.println("Support: PrepareReilabilityJavaSource "+e);}
		return source;
	}
	
	public String PrepareJavaSource(String source,String NomeMetodo)
	{

		System.out.println("Support:PrepareJavaSource");
		String JavaString=source;
		StringBuffer buffer=null;
		StringBuffer javabuffer = new StringBuffer(source);
		buffer = new StringBuffer("%code%");
		//System.out.println(NomeMetodo);
		try
		{
			//JavaString = JavaString.replaceAll("public class", "%import% public class ");
			String stringa_implement = "\\s+implements\\s+[a-zA-Z\\p{Punct}\\p{Alnum}]+\\s+";
			Pattern pattern_implement = Pattern.compile(stringa_implement,Pattern.MULTILINE);
			Matcher m_implement = pattern_implement.matcher(JavaString);
			while(m_implement.find())
			{
				//System.out.println("++++++++++++++++++++++++++++++Trovato un match!"+ m_implement.group());
				JavaString=m_implement.replaceFirst(" {");
				
			}
			
			String stringa_class = "public\\s+class\\s+\\p{Alpha}[\\p{Punct}\\p{Alnum}]+\\s+[{]*";
			Pattern pattern_class = Pattern.compile(stringa_class,Pattern.MULTILINE);
			Matcher m_class = pattern_class.matcher(JavaString);
			while(m_class.find())
			{
				//System.out.println("Trovato un match!"+ m_class.group());
				JavaString=m_class.replaceAll(" %import% "+m_class.group()+" %WL_Function% ");
			}
		}
		catch(Exception e){System.out.println("Support: PrepareJavaSource"+e);}
		try
		{
			//public [a-zA-Z]+ listenFattoriale_rpc[(]([a-zA-Z]+ [0-9a-zA-Z]+[,]?)+[)] throws java.rmi.RemoteException [{]
			Pattern pattern = Pattern.compile(NomeMetodo, Pattern.MULTILINE);
			Matcher m = pattern.matcher(JavaString);

			while(m.find())
			{
				//System.out.println("MATCH "+NomeMetodo+" "+m.group() );
				JavaString=m.replaceAll(" %static% "+m.group()+" %code% ");
				
			}
		}
		catch(Exception e){System.out.println("Support: PrepareJavaSource"+e);}
		try
		{
			JavaString=JavaString.replace("%", "$");

		}
		catch(Exception e){System.out.println("Support: PrepareJavaSource"+e);}
		//System.out.println(JavaString);
		return JavaString;
	}
	//-------//
//	Check OK
	public String GetJavaSource(String filename)
	{
		System.out.println("Support:getJavaSource ");
		String Stringa="";
		try
		{
			FileInputStream filein = null;
			InputStreamReader filebufIN = null;
			BufferedReader in = null;	
			try
			{
				//lettura
				filein = new FileInputStream(filename);
				filebufIN = new InputStreamReader(filein);
				in = new BufferedReader(filebufIN);		
			}
			catch(Exception e)
			{
				System.out.println("Support getJavaSource: "+e);
			}
			try
			{
				while(in.ready())
				{
					Stringa=Stringa+" "+in.readLine()+"\n";//adesso in contenuto ho tutto il testo del file		 
				}
			}
			catch(Exception e)
			{System.out.println("Support: GetJavaSource"+e);}
			
		}
		catch(Exception e){System.out.println("Support: GetJavaSource"+e);}
		return Stringa;
	}
//	------****************************************************------------
	public void PutJavaSource(String filename, String source) 
	{
		System.out.println("putJavaSource");
		source = source.replaceAll("\n"," ");
		FileOutputStream fileout = null;
		OutputStreamWriter fileBufOut = null;
		BufferedWriter out= null;
		try
		{
			fileout = new FileOutputStream(filename);
			fileBufOut = new OutputStreamWriter(fileout);
			out = new BufferedWriter(fileBufOut);
		}
		catch(Exception e){System.out.println("Support Putjavasource "+e);}
		try
		{
			out.write(source);
			out.close();
		}
		catch(Exception e)
		{System.out.println("Support PutJavasource 2 "+e);}

	}
}
	
	
	
	
	
	
	
	