package puppet;


import java.util.HashSet;
import java.util.Iterator;

import org.ggf.schemas.graap.x2005.x09.wsAgreement.GuaranteeTermType;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.TermCompositorType;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.TermTreeType;

public class TermParser 
{
	private String WSDD_File;
	private String Destination;
	private WSAManipulator WSA_obj;
	private ServiceLevelObjectiveManipulator SLO_obj;
    private HashSet<String> serviceList;
	String QCFile;
	
	
	
	
	public TermParser(String WSDD_File_,String Destination_,WSAManipulator WSA_obj_,ServiceLevelObjectiveManipulator SLO_obj_,String QCFile_ )
	{
		WSDD_File = WSDD_File_;
		Destination = Destination_;
		WSA_obj = WSA_obj_;
		SLO_obj = SLO_obj_;
		QCFile = QCFile_;
        
        serviceList = new HashSet<String> ();
	}

//	---**********************************************************************************
	private void Recursive(String [] Elenco,TermCompositorType TCT)
	{
		//nel caso in cui ci siano dei garanteeTermType
		System.out.println("Recursive");
		try
		{
			Iterator GTT_iterator = TCT.getGuaranteeTermList().iterator();
			while(GTT_iterator.hasNext())
			{
				GuaranteeTermType GTT_Temp = (GuaranteeTermType)GTT_iterator.next();
				this.RecursiveGTT(Elenco, GTT_Temp);
			}
		}
		catch(Exception e){}
		//nel caso in cui ci siano dei sottorami ExactlyOne
		try
		{
			Iterator E1_iterator = TCT.getExactlyOneList().iterator();
			while(E1_iterator.hasNext())
			{
				TermCompositorType TCT_temp = (TermCompositorType)E1_iterator.next();
				this.Recursive(Elenco, TCT_temp);
			}
		}
		catch(Exception e){}
//		nel caso in cui ci siano dei sottorami OneOrMore
		try
		{
			Iterator OneOrMore_iterator = TCT.getOneOrMoreList().iterator();
			while(OneOrMore_iterator.hasNext())
			{
				TermCompositorType OneOrMore_temp = (TermCompositorType)OneOrMore_iterator.next();
				this.Recursive(Elenco,OneOrMore_temp);
			}
		}
		catch(Exception e){}
//		nel caso in cui ci siano dei sottorami All
		try
		{
			Iterator All_iterator = TCT.getAllList().iterator();
			while(All_iterator.hasNext())
			{
				TermCompositorType All_temp = (TermCompositorType)All_iterator.next();
				this.Recursive(Elenco, All_temp);
			}
		}
		catch(Exception e){}
		
	}
//---**********************************************************************************
	private void RecursiveGTT(String[] Elenco,GuaranteeTermType GTT)
	{
		GuaranteeTermActivator GTTActivator = new GuaranteeTermActivator();
		String nomeServizio = GTT.getName();
		for(int i=0;i<Elenco.length;i++)
		{
			if(Elenco[i].equals(nomeServizio))
			{
				System.out.println("TermParser "+GTT.getName());
				GTTActivator.ParseGuaranteeTerm(GTT, WSDD_File, Destination, WSA_obj, SLO_obj, QCFile);
                updateServiceList(GTTActivator.getServerSideServicesList());
			}
		}
	}
//---**********************************************************************************
	public void RecursiveTermParser(String[] Elenco,TermTreeType termTree)
	{
		//nel caso in cui ci siano dei sottorami ExactlyOne
		System.out.println("RecursiveTermParser");
		try
		{
			Iterator E1_iterator = termTree.getAll().getExactlyOneList().iterator();
			while(E1_iterator.hasNext())
			{
				TermCompositorType TCT_temp = (TermCompositorType)E1_iterator.next();
				this.Recursive(Elenco, TCT_temp);
			}
		}
		catch(Exception e){}
//		nel caso in cui ci siano dei sottorami OneOrMore
		try
		{
			Iterator OneOrMore_iterator = termTree.getAll().getOneOrMoreList().iterator();
			while(OneOrMore_iterator.hasNext())
			{
				TermCompositorType OneOrMore_temp = (TermCompositorType)OneOrMore_iterator.next();
				this.Recursive(Elenco,OneOrMore_temp);
			}
		}
		catch(Exception e){}
//		nel caso in cui ci siano dei sottorami All
		try
		{
			Iterator All_iterator = termTree.getAll().getAllList().iterator();
			while(All_iterator.hasNext())
			{
				TermCompositorType All_temp = (TermCompositorType)All_iterator.next();
				this.Recursive(Elenco, All_temp);
			}
		}
		catch(Exception e){}
//		nel caso in cui ci siano dei garanteeTermType
		try
		{
			Iterator GTT_iterator = termTree.getAll().getGuaranteeTermList().iterator();
			while(GTT_iterator.hasNext())
			{
				GuaranteeTermType GTT_Temp = (GuaranteeTermType)GTT_iterator.next();
				this.RecursiveGTT(Elenco, GTT_Temp);
			}
		}
		catch(Exception e){}

	
	}
//---**********************************************************************************
	
    private void updateServiceList (HashSet<String> inServiceList){
        Iterator<String> list = inServiceList.iterator();
        String element;
        while (list.hasNext()){
            element = list.next();
            serviceList.add(element);
        }
    }

/*
 * Invoked after the ParseGuaranteeTerm returns the list of file name of those services 
 * that will exported server side. it does not include services that only exports methods 
 * for the workload generations.
*/
    public HashSet<String> getServiceList() {
        return serviceList;
    }
    
}
