package puppet;


import it.cnr.isti.setest0.mappedQC.MappedQCDocument;
import it.cnr.isti.setest0.puppetQC.NOTDocument;
import it.cnr.isti.setest0.puppetQC.ORDocument;
import it.cnr.isti.setest0.puppetQC.PuppetQCDocument;
import it.cnr.isti.setest0.puppetQC.BooleanExpressionDocument.BooleanExpression;
import it.cnr.isti.setest0.puppetQC.BooleanExpressionDocument;
import it.cnr.isti.setest0.puppetQC.NumericBooleanExpressionDocument;
import it.cnr.isti.setest0.puppetQC.StringBinaryExpressionDocument;
import it.cnr.isti.setest0.puppetQC.ANDDocument.AND;
import it.cnr.isti.setest0.puppetQC.NOTDocument.NOT;
import it.cnr.isti.setest0.puppetQC.NumericBinaryExpressionDocument.NumericBinaryExpression;
import it.cnr.isti.setest0.puppetQC.NumericBooleanExpressionDocument.NumericBooleanExpression;
import it.cnr.isti.setest0.puppetQC.NumericTypeDocument.NumericType;
import it.cnr.isti.setest0.puppetQC.ORDocument.OR;
import it.cnr.isti.setest0.puppetQC.StringBinaryExpressionDocument.StringBinaryExpression;
import it.cnr.isti.setest0.puppetQC.StringTypeDocument.StringType;
import it.cnr.isti.setest0.puppetQC.ANDDocument;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.List;
import org.antlr.stringtemplate.StringTemplate;
import org.apache.xmlbeans.XmlObject;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.GuaranteeTermType;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.TermTreeType;

import com.sun.rmi.rmid.ExecOptionPermission;

public class WSAManipulator 
{
	public String mapQCFile = "";
	public WSAManipulator(String QCFile)
	{
		mapQCFile = QCFile;
	}
	public WSAManipulator()
	{
	}
//	----***************************************************************************----\\
	public Iterator GetGuaranteeTermList(TermTreeType termTree)
	{
		List lista  = termTree.getAll().getGuaranteeTermList();	
		Iterator i=lista.iterator(); //i contiene i blocchi GuaranteeTerm
		return i;
	}
//	----***************************************************************************----\\
	public String getOperatore(Object obj_)
	{
		//--System.out.println("getOperatore....");
		//System.out.println(obj_);
		NumericType TypeVar = (NumericType) obj_;
		String Operatore = "";
		try
		{
			//caso in cui operando sinistro sia un valore
			TypeVar = (NumericType) obj_;
			Operatore = TypeVar.getValue().toString();
			//System.out.println("L'operatore � una valore");	
		}
		catch(Exception e)
		{
			try
			{
				//caso in cui operando sinistro sia un'altra espressione numerica
				NumericBinaryExpression newExpr = ((NumericType)obj_).getNumericBinaryExpression();
				Operatore = Operatore+getNumericBinaryTag(newExpr);
				//Operatore = Operatore+"�"+getNumericBinaryTag(newExpr)+"�";
				//System.out.println("L'operatore � una espressione numerica");
			}
			catch(Exception f)
			{
				try
				{	
//					caso in cui operando sinistro sia una variabile
					TypeVar = (NumericType) obj_;
					Operatore = TypeVar.getVariable();
					//System.out.println("L'operatore � una variabile");
			
				}
				catch(Exception g)
				{
					/*//caso in cui operando sinistro sia un'altra espressione su stringhe
					StringBinaryExpressionDocument newExpr = (StringBinaryExpressionDocument)TypeVar.getNumericBinaryExpression();
					Operatore = Operatore+"("+getStringBinaryTag(newExpr)+")";
					System.out.println("L'operatore � una espressione su stringhe");*/
				}
			}
		}
		return Operatore;
		
	}
//	----***************************************************************************----\\
	public String getNumericBinaryTag(NumericBinaryExpression expr)
	{
		//--System.out.println("getNumericBinaryTag....");
		//System.out.println("WSAMan : getNumericBinaryTag"+'\n'+expr.toString());
		String stringa="";
		//NumericType TypeVar1 =null;
		//NumericType TypeVar2 =null;
		String OperandoDestro="",OperandoSinistro="";
		NumericBinaryExpression espressione = expr;
		List ListVariabile = espressione.getNumericTypeList();	
		//System.out.println("WSAMan : getNumericBinaryTag");
		Iterator iter = ListVariabile.iterator();
		Object obj_ = null;
		//OperandoSinistro = iter.next().toString();
		String op = espressione.getOp().toString();
		//verifico che l'operando sinistro sia un valore o una variabile
		//in caso contrario applico ricorsivamente la funzione
		obj_ = iter.next();
		OperandoSinistro = getOperatore(obj_);
		obj_ = iter.next();
		OperandoDestro = getOperatore(obj_);
		
		stringa = "("+OperandoSinistro+" "+op+" "+OperandoDestro+")";
		//System.out.println("getNumericBinaryTag "+stringa);
		//nel caso in cui la seconda variabile sia in realt� un valore:
		return stringa;
	}
	
//----***************************************************************************----\\
	public String getStringBinaryTag(StringBinaryExpression expr)
	{
		//--System.out.println("getStringBinaryTag....");
		String stringa="";
		StringBinaryExpression espressione = expr;
		List ListVariable = espressione.getStringTypeList();
		Iterator iter = ListVariable.iterator();
		String Var1 = (String)iter.next();
		String Var2 = (String)iter.next();
		String op = espressione.getOp().toString();
		
		stringa ="("+Var1+"#"+op+"#"+Var2+")";
		//System.out.println("getStringBinaryTag "+stringa);
		return stringa;
	}

//	----***************************************************************************----\\
	public String ParseBooleanExpression(BooleanExpression BooleanDoc)
	{
		//--System.out.println("ParseBooleanExpression");
		String Variabile = "";
		String Valore = "";
		String Op ="";
		String StrdiRitorno = "";
		Variabile = BooleanDoc.getVariable();
		Valore = BooleanDoc.getValue().toString();
		Op = BooleanDoc.getOperator().toString();
			
		StrdiRitorno = "("+Variabile+" "+Op+" "+Valore+")";
		return StrdiRitorno;
	}
	
//	----***************************************************************************----\\	
	public String ParseStringExpression(StringBinaryExpression StrBinDoc)
	{
		//--System.out.println("ParseStringExpression....");
		String OperandoSinistro = "";
		String OperandoDestro   = "";
		String Operatore = "";
		
		Iterator iter = StrBinDoc.getStringTypeList().iterator();
		//operatore destro
		//devo verificare che tipo di oggetti si tratta: variabile, operatore o espressione
		Object obj_ = iter.next();
		try{OperandoDestro=((StringType)obj_).getVariable();}
		catch(Exception e){}
		try{OperandoDestro=((StringType)obj_).getValue().toString();}
		catch(Exception e){}
		try{OperandoDestro=getStringBinaryTag( ((StringType)obj_).getStringBinaryExpression() );}
		catch(Exception e){}

		//Operatore di confronto
		try{Operatore = StrBinDoc.getOp().toString();}										catch(Exception e){}
		//operando Sinistro
		obj_ = iter.next();
		try{OperandoSinistro=((StringType)obj_).getVariable();}								catch(Exception e){}
		try{OperandoSinistro=((StringType)obj_).getValue().toString();}						catch(Exception e){}
		try{OperandoSinistro=getStringBinaryTag( ((StringType)obj_).getStringBinaryExpression() );}
																							catch(Exception e){}
								
		String strDiRitorno=MapStringExpression(OperandoSinistro,OperandoDestro,Operatore);	
		
		return strDiRitorno;
	}
//	----***************************************************************************----\\	
	public String ParseNumericExpression(NumericBooleanExpression NumBoolDoc)
	{
		//--System.out.println("ParseNumeriExpression....");
		String OperandoSinistro = "";
		String OperandoDestro   = "";
		String Operatore = "";
		Iterator iter = NumBoolDoc.getNumericTypeList().iterator();
		//operatore destro
		//devo verificare che tipo di oggetti si tratta: variabile, operatore o espressione
		Object obj_ = iter.next();
		try{OperandoDestro=((NumericType)obj_).getVariable();}
		catch(Exception e){}
		try{OperandoDestro=((NumericType)obj_).getValue().toString();}
		catch(Exception e){}
		try{OperandoDestro=getNumericBinaryTag( ((NumericType)obj_).getNumericBinaryExpression() );}
		catch(Exception e){}
		
		//Operatore di confronto
		try{Operatore = NumBoolDoc.getOpConfr().toString();}	catch(Exception e){}
		
		//operando Sinistro
		obj_ = iter.next();
		try{OperandoSinistro=((NumericType)obj_).getVariable();}							catch(Exception e){}
		try{OperandoSinistro=((NumericType)obj_).getValue().toString();}					catch(Exception e){}
		try{OperandoSinistro=getNumericBinaryTag( ((NumericType)obj_).getNumericBinaryExpression() );}
																							catch(Exception e){}																		
		return ("("+OperandoDestro+Operatore+OperandoSinistro+")");
		
	}
//	----***************************************************************************----\\
	public String ParseANDCondition(AND ANDDoc)
	{
		//--System.out.println("ParseANDCOndition....");
		String ritorno = "";
//		Caso in cui si siano dei blocchi StringExpression
		try
		{
			Iterator ItString = ANDDoc.getStringBinaryExpressionList().iterator();
			while(ItString.hasNext())
			{
				StringBinaryExpression SBE = (StringBinaryExpression)ItString.next();
				
				ritorno = ritorno + ParseStringExpression(SBE) + "&&";
			}
			
		}
		catch(Exception e){}
		//Caso in cui si abbiano dei blocchi NumericExpression
		try
		{
			Iterator ItNumeric = ANDDoc.getNumericBooleanExpressionList().iterator();
			while(ItNumeric.hasNext())
			{
				NumericBooleanExpression NBE = (NumericBooleanExpression)ItNumeric.next();//StringBinaryExpressionDocument.Factory.parse(ItString.next().toString());
				
				ritorno = ritorno + ParseNumericExpression(NBE) + "&&";
			}
		}
		catch(Exception e){}
		//Caso in cui si abbiano dei blocchi BooleanExpression
		try
		{
			Iterator ItBoolean = ANDDoc.getBooleanExpressionList().iterator();
			while(ItBoolean.hasNext())
			{
				BooleanExpression BE = (BooleanExpression)ItBoolean.next();//StringBinaryExpressionDocument.Factory.parse(ItString.next().toString());
				
				ritorno = ritorno + ParseBooleanExpression(BE) + "&&";
			}
		}
		catch(Exception e){}
        if (ritorno.endsWith("&&"))
            ritorno = ritorno.substring(0, ritorno.length()-2);
		//Nel caso in cui si abbiano degli OR oppure NOT annidati
		try
		{
			OR ORDoc = ANDDoc.getOR();
			if(ORDoc!=null)
			{
				ritorno = ritorno + "&&" +ParseORCondition(ORDoc) ;
			}
		}
		catch(Exception e){}
		try
		{
			NOT NOTDoc = ANDDoc.getNOT();
			if(NOTDoc!=null)
			{
				ritorno = ritorno + "&&" +ParseNOTCondition(NOTDoc) ;
			}
		}
		catch(Exception e){}
		return  "("+ritorno+")";
	}
//	----***************************************************************************----\\	
	public String ParseORCondition(OR ORDoc)
	{
		//--System.out.println("ParseORCOndition....");
		String ritorno = "";
//		Caso in cui si siano dei blocchi StringExpression
		try
		{
			Iterator ItString = ORDoc.getStringBinaryExpressionList().iterator();
			while(ItString.hasNext())
			{
				StringBinaryExpression SBE = (StringBinaryExpression)ItString.next();
				
				ritorno = ritorno + ParseStringExpression(SBE) + "||";
			}
			
		}
		catch(Exception e){}
		//Caso in cui si abbiano dei blocchi NumericExpression
		try
		{
			Iterator ItNumeric = ORDoc.getNumericBooleanExpressionList().iterator();
			while(ItNumeric.hasNext())
			{
				NumericBooleanExpression NBE = (NumericBooleanExpression)ItNumeric.next();//StringBinaryExpressionDocument.Factory.parse(ItString.next().toString());
				
				ritorno = ritorno + ParseNumericExpression(NBE) + "||";
			}
		}
		catch(Exception e){}
		//Caso in cui si abbiano dei blocchi BooleanExpression
		try
		{
			Iterator ItBoolean = ORDoc.getBooleanExpressionList().iterator();
			while(ItBoolean.hasNext())
			{
				BooleanExpression BE = (BooleanExpression)ItBoolean.next();//StringBinaryExpressionDocument.Factory.parse(ItString.next().toString());
				
				ritorno = ritorno + ParseBooleanExpression(BE) + "||";
			}
		}
		catch(Exception e){}
        if (ritorno.endsWith("||"))
            ritorno = ritorno.substring(0, ritorno.length()-2);
		//Nel caso ci sia un sottoramo AND
		try
		{
			AND ANDDoc = ORDoc.getAND();
			if(ANDDoc != null)
			{
				ritorno = ritorno + "&&" +ParseANDCondition(ANDDoc) ;
			}
		}
		catch(Exception e){}
		try
		{
			NOT NOTDoc = ORDoc.getNOT();
			if(NOTDoc != null)
			{
				ritorno = ritorno + "&&" +ParseNOTCondition(NOTDoc);
			}
		}
		catch(Exception e){}
		return  "("+ritorno+")";
	}
//	----***************************************************************************----\\	
	public String ParseNOTCondition(NOT NOTDoc)
	{
		//--System.out.println("ParseNOTCOndition....");
		String ritorno = "";	
//		Caso in cui si siano dei blocchi StringExpression
		try
		{
				StringBinaryExpression SBE = NOTDoc.getStringBinaryExpression();
				ritorno = ritorno + "!" + ParseStringExpression(SBE);		
		}
		catch(Exception e){}
		//Caso in cui si abbiano dei blocchi NumericExpression
		try
		{
			NumericBooleanExpression NBE = (NumericBooleanExpression)NOTDoc.getNumericBooleanExpression();
			ritorno = ritorno + "!" + ParseNumericExpression(NBE);
		}
		catch(Exception e){}
//		Caso in cui si abbiano dei blocchi BooleanExpression
		try
		{
			BooleanExpression BE = (BooleanExpression)NOTDoc.getBooleanExpression();
			ritorno = ritorno + "!" + ParseBooleanExpression(BE);
		}
		catch(Exception e){}
		//Nel caso ci sia un sottoramo AND
		try
		{
			AND ANDDoc = NOTDoc.getAND();
			if(ANDDoc != null)
			{
				ritorno = ritorno + "!" +ParseANDCondition(ANDDoc) ;
			}	
		}
		catch(Exception e){}
		//Nel caso ci sia un sottoramo OR
		try
		{
			OR ORDoc = NOTDoc.getOR();
			if(ORDoc != null)
			{
				
				ritorno = ritorno + "!" +ParseORCondition(ORDoc) ;
			}
		}
		catch(Exception e){}
		
		return "("+ritorno+")";
	}
//	----***************************************************************************----\\	
	/*All'interno del WSagreement GuaranteeTerm -> qualifing condition ci sono i criteri per il QOS
	 * del servizio.
	 * Quello che fa questa funzione � di parsare il file xml e successivamente creare del sorgente java
	 * per la verifica di tali criteri.
	 * Il codice generato verr� successivamente inserito all'interno del file java per la creazione del 
	 * servizio
	 */
	public String MapQualifyingcondition(PuppetQCDocument puppet)
	{
		String ritorno = "";
		//String source="/Users/Aran/Documents/Tirocinio/Documentazione/Aran/PuppetMappedQC.xml";
		System.out.println("MapqualifyingCondition");
		//Rappresenta il file xml nel cui interno � scritto il codice del WSAgreement
		PuppetQCDocument puppet_doc = puppet;
		//Rappresenta il file xml nel cui interno � scritto il mapping del codice java
		//PuppetMappedDocument Puppet_mapped = null;
		//String Expression="";
		//File mappedFile = null;
		
		NumericBooleanExpression NumBoolDoc = null;
		StringBinaryExpression StrBinDoc = null;
		BooleanExpression BooleanDoc= null;
		ANDDocument ANDDoc = null;
		ORDocument  ORDoc = null;
		NOTDocument NOTDoc = null;
		//List BinNumCond = null;	//lista delle espressioni numeriche
		//List UnaStrCond = null; //lista delle espressioni binarie su stringhe 
		//List BinStrCond = null; //lista delle espressioni unarie  su stringhe
		try
		{
			// Caso in cui � presente una espressione numerica
			try
			{
				NumBoolDoc = NumericBooleanExpressionDocument.Factory.parse(puppet_doc.getPuppetQC().toString()).getNumericBooleanExpression();
			}
			catch(Exception e){}
			//Funzione che gestisce il parsing dei tag NumericExpression
			//ritorna la stringa con il codice java corrispondente
			ritorno = ParseNumericExpression(NumBoolDoc);
			//
		}catch(Exception e){}
		//---------------------------------
		//Caso in cui sia un'espressione con stringhe
		try
		{
			try
			{
				StrBinDoc = StringBinaryExpressionDocument.Factory.parse(puppet_doc.getPuppetQC().toString()).getStringBinaryExpression();
			}
			catch(Exception e){}
			//Funzione che gestisce il parsing dei tag StringBinaryExpression
			//ritorna la stringa con il codice java corrispondente
			ritorno = ParseStringExpression(StrBinDoc);
			//
		}catch(Exception e){}
		//Caso in cui ci sia un'espressione booleana
		try
		{
			try
			{
				BooleanDoc = BooleanExpressionDocument.Factory.parse(puppet_doc.getPuppetQC().toString()).getBooleanExpression();
			}
			catch(Exception e){}
			//Funzione che gestisce il parsing dei tag StringBinaryExpression
			//ritorna la stringa con il codice java corrispondente
			ritorno = ParseBooleanExpression(BooleanDoc);
			//
		}catch(Exception e){}
		
		//Caso in cui ci sia un ramo AND
		try
		{
			//--System.out.println("siamo nel ramo and");
			try
			{
				ANDDoc = ANDDocument.Factory.parse(puppet_doc.getPuppetQC().toString());
				//Funzione che gestisce il parsing dei tag AND e relativi sottoTag
				//ritorna la stringa con il codice java corrispoondente
				ritorno = ParseANDCondition(ANDDoc.getAND());
			}
			catch(Exception e){}
			
		}
		catch(Exception e){}
		//Caso in cui ci sia un ramo OR
		try
		{
			//--System.out.println("siamo nel ramo or");
			try
			{
				ORDoc = ORDocument.Factory.parse(puppet_doc.getPuppetQC().toString());
				//Funzione che gestisce il parsing dei tag OR e relativi sottotag
				//ritorna la stringa con il codice java corrispondente
				ritorno = ParseORCondition(ORDoc.getOR());
			}
			catch(Exception e){}
			
		}
		catch(Exception e){}	
		//Caso in cui ci sia un ramo NOT
		try
		{
			//--System.out.println("siamo nel ramo NOT");
			try
			{
				NOTDoc = NOTDocument.Factory.parse(puppet_doc.getPuppetQC().toString());
				//Funzione che gestisce il parsing dei tag NOT e relativi sottotag
				//ritorna la stringa con il codice java corrispondente
				ritorno = ParseNOTCondition(NOTDoc.getNOT());
			}
			catch(Exception e){}
			
		}
		catch(Exception e){}	
		//System.out.println("ritorno : "+ritorno);
		return ritorno;
	}
//	----***************************************************************************----\\
	public String MapStringExpression(String OperandoDestro, String OperandoSinistro, String Operatore)
	{
		//--System.out.println("MapStringExpression....");
		String ritorno = "";
		MappedQCDocument mapped = null;
		try
		{	
            File f = new File(mapQCFile);//"/Users/Aran/Documents/Tirocinio/Documentazione/Aran/MappedQC.xml");
			mapped = MappedQCDocument.Factory.parse(f);
		}
		catch(Exception e){System.out.println("MapStringExpression: "+e );}
		
		
		if(Operatore.equals("different"))
		{
			String stringa = mapped.getMappedQC().getStringExpression().getDifferent();
			
			StringTemplate t = new StringTemplate(stringa);
			t.setAttribute("Var1", OperandoSinistro);
			t.setAttribute("Var2", OperandoDestro);
			//ritorno = t; 
		}
		if(Operatore.equals("equal"))
		{
			String stringa = mapped.getMappedQC().getStringExpression().getEqual();
			
			StringTemplate t = new StringTemplate(stringa);
			t.setAttribute("Var1", OperandoSinistro);
			t.setAttribute("Var2", OperandoDestro);
			ritorno = t.toString(); 
		}
		//System.out.println(ritorno);
		return ritorno;
	}
	
//	----***************************************************************************----\\
	//Check still
	public String getQualifyingCondition(GuaranteeTermType GTT)
	{
		//--System.out.println("getQualifyngCondition....");
		String str="";
		XmlObject obj=null;
		PuppetQCDocument puppet = null;
		//--System.out.println("WSAMan :getQualifyngCondition");
		try
		{
//			Prendo il ramo dei QualifyingCondition
			obj=GTT.getQualifyingCondition();
			puppet=PuppetQCDocument.Factory.parse(obj.toString());
			//---------------**************fino a qui**************-----------------//
			str =str+MapQualifyingcondition(puppet);	
		}
		catch(Exception e)
		{System.out.println("WSAMan :getQualifyngCondition: "+e);}
		
		return str;
	}
	//-----//

    
	
}
