package puppet.mobility;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.wsdl.Binding;
import javax.wsdl.Definition;
import javax.wsdl.Operation;
import javax.wsdl.PortType;
import javax.wsdl.WSDLException;

import org.antlr.stringtemplate.StringTemplate;

import com.ibm.wsdl.xml.WSDLReaderImpl;

public class ClassCodeProcessor4Mobility {

  private String name;
  private String targetMethodsPrefix;
//Are the qualificator such as "private", "public" and so on    
  private String classPrefix;  
  private String WSDLPath;
  private PatternsReader4Mobility mobilityPatterns;
  private MobilityVariableWrapper mobilityVarWrapper;
  
  public ClassCodeProcessor4Mobility (String className, String WSDLPath, String targetMethodsPrefix){
      this.name = className;
      this.WSDLPath = WSDLPath;
      this.targetMethodsPrefix = targetMethodsPrefix;

      this.mobilityPatterns = new PatternsReader4Mobility();
      this.mobilityVarWrapper = new MobilityVariableWrapper();      
  }

  public ClassCodeProcessor4Mobility (String className, String WSDLPath){
      this(className,WSDLPath,"public");
  }
  
//Note that the method type it will not be set!! 
  public ArrayList<MethodCodeProcessor4Mobility> extractMethodsNameOnly (String code){
      WSDLReaderImpl wsdlService = new WSDLReaderImpl();
      Definition wsdlDocument = null;

      try {
          wsdlDocument = wsdlService.readWSDL(this.WSDLPath);
      } catch (WSDLException e) {
          e.printStackTrace();
      }
      
      ArrayList<MethodCodeProcessor4Mobility> methodList = new ArrayList<MethodCodeProcessor4Mobility>();
      String methodName;
      String methodType;
      boolean foundIt = false;

      String bindingName = this.name.replaceFirst("BindingImpl", "Binding");
      
      System.out.println(this.name+"-->"+bindingName);
      
      Binding bindingEntry = null; 
      Iterator bindings =  wsdlDocument.getBindings().values().iterator();
      foundIt = false;
      
      while ((bindings.hasNext())&&(!foundIt)){
          bindingEntry = (Binding) bindings.next();
          foundIt = bindingEntry.getQName().getLocalPart().equalsIgnoreCase(bindingName);
      }
      
      if (foundIt){
          PortType portTypeEntry = bindingEntry.getPortType();

          System.out.println("Port Name --> " + portTypeEntry.getQName().getLocalPart());

          List operationList = portTypeEntry.getOperations();
          Iterator it = operationList.iterator();
          Operation operation;
          
          while (it.hasNext()) {
              operation = (Operation) it.next();
              methodName = operation.getName();
              System.out.println("Operation Name --> " + methodName );
              methodList.add(new MethodCodeProcessor4Mobility(methodName, targetMethodsPrefix));
          }
      }              
     return methodList;
  }
          
  
  public String parseClass (String code){
      String localCode = code;

      ArrayList<MethodCodeProcessor4Mobility> methodsList = extractMethodsNameOnly(localCode);

      for (int i=0; i<methodsList.size();i++){
          localCode = methodsList.get(i).parseCode(localCode);
      }
                  
      return localCode; 
  }
  
  private String exchangePortion(String originalString, int beginRegion, int endRegion, String newString){
      int originalStringLength =  originalString.length();
      String exchangedString = originalString.substring(0,beginRegion)+newString+originalString.substring(endRegion, originalStringLength);            
      return exchangedString;
  }
    
}
