package puppet.mobility;

import it.cnr.isti.puppet.mobilityPatterns.MobilityPatternsDocument;
import it.cnr.isti.puppet.mobilityPatterns.MobilityPatternsDocument.MobilityPatterns;

import java.io.File;
import java.io.IOException;

import javax.xml.namespace.QName;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.xmlbeans.XmlException;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.AgreementOfferDocument;

import constant.Constant;

import puppet.commonFeatures.CommonPatternsReader;

public class PatternsReader4Mobility extends CommonPatternsReader {

    private static final String DEFAULT_MOBILITY_PREFIX = "mobilityPrefix";
    
    public PatternsReader4Mobility (){
        super(DEFAULT_MOBILITY_PREFIX);
    }
    
    public PatternsReader4Mobility (String invocationTimeVarName, String returnValueVarName){        
        super(DEFAULT_MOBILITY_PREFIX,invocationTimeVarName,returnValueVarName);
    }

    public String getMobilityOracleInvocationCode (){
        String varCode = "/* In PatternsReader4Mobility.java any invocation code for the Mobility Oracle was generated */";
        MobilityPatternsDocument mobilityPatternsDoc = null;
        File mobilityPatternsFile=null;
        try {
                mobilityPatternsFile=new File(Constant.DEFAULT_MOBILITY_PATTERNS_FILENAME);
                mobilityPatternsDoc = MobilityPatternsDocument.Factory.parse(mobilityPatternsFile);
                MobilityPatterns mobilityPatterns = mobilityPatternsDoc.getMobilityPatterns();
                String tmp = mobilityPatterns.getOracleInvocationPatter();
// If the tmp string is null or has just blanks the default message of is not overwritten
                if (!(tmp == null) && !(tmp.trim().isEmpty())){
                    varCode = tmp;
                }
        } catch (XmlException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }  
        
        return varCode;
    }

}
