package puppet.slang;

import java.math.BigInteger;

import it.cnr.isti.setest0.puppetSLO.PuppetSLODocument;
import it.cnr.isti.setest0.puppetSLO.PuppetSLODocument.PuppetSLO;

import org.apache.xmlbeans.XmlObject;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.GuaranteeTermType;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.ServiceRoleType;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.TermCompositorType;
import org.w3c.dom.Node;

import uk.ac.ucl.cs.slangta.jmi.impl.slang.SLA_Impl;

public class LatencyGuaranteeTermsGenerator extends GuaranteeTermGenerator {

	private BigInteger latency;
	
    public LatencyGuaranteeTermsGenerator(SLA_Impl slangSpecification){
        super(slangSpecification);
    }
    
    public LatencyGuaranteeTermsGenerator (SLA_Impl slangSpecification, double lat, TermCompositorType compositorElement){
    	super(slangSpecification,compositorElement);
        String mystr = (new Double(lat)).toString();
        mystr= (mystr.split("\\."))[0];
    	latency = new BigInteger(mystr);
    }
    
    //@Override
    /*
     * Appends GuaranteeTerms expessing Latency constraints to the
     * TermCompositorType and returns it
     */
    public TermCompositorType generate() {
        GuaranteeTermType latencyGT = compositorElement.addNewGuaranteeTerm();

        latencyGT.setObligated(ServiceRoleType.SERVICE_PROVIDER);
        latencyGT.setName("LatencyGT_" + guaranteeTermId);
        guaranteeTermId++;

        generateServiceScope(latencyGT);
        generateBusinessValueList(latencyGT);
        generateQualifyingCondition(latencyGT);

        Node importedNode;
        XmlObject sloElement = latencyGT.addNewServiceLevelObjective();

        PuppetSLODocument pSLODoc = PuppetSLODocument.Factory.newInstance();
        pSLODoc.addNewPuppetSLO();
        PuppetSLO pSLO = pSLODoc.getPuppetSLO();
        pSLO.addNewLatency();

        // -- A COMMENT TO FRANCO --
        // HERE THE VALUES HOLD BY slangSpecification
        pSLO.getLatency().setValue(latency);

        // -- A COMMENT TO FRANCO --
        // FOR THE MOMENT IGNORE THIS PART
        pSLO.getLatency().addNewDistribution();
        pSLO.getLatency().getDistribution().setGaussian("10");

        // System.out.println(pSLODoc.xmlText());

        importedNode = sloElement.getDomNode().getOwnerDocument().importNode(pSLO.getDomNode(), true);
        sloElement.getDomNode().appendChild(importedNode);

        return compositorElement;
    }

}
